﻿
@{
    ViewBag.Title = "List Users";
    ViewBag.currentPage = "user";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="card">
    <div class="card-header d-flex justify-content-between">
        <div>
            <button id="addUser" class="btn btn-primary" data-toggle="modal" data-target="#modalAddUser"><i class="fas fa-plus-circle mr-1"></i>Add User</button>
        </div>
        <div class="ml-auto p-2">
            <button class="btn btn-info " id="btn-reload">Reload Data</button>
        </div>
        <!--Reload animasi-->
    </div>
    <div class="card-body">
        <table id="user-table" class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>Customer ID</th>
                    <th>Customer Name</th>
                    <th>Email Address</th>
                    <th>Status</th>
                    <th>Verified</th>
                    <th>Activation</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
</div>

<div class="modal fade" id="modalAddUser" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <form class="form-parsley" id="form-create">
                <div class="modal-header px-4 bg-light">
                    <h4 class="modal-title" id="addModalLabel">Add New User</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
                <div class="modal-body p-4">
                    <div class="row">
                        <div class="col-sm-12">
                            <!--<div class="form-group col-sm-8">
        <label for="CustID">Customer Id *</label>-->
                            @*<select name="CustID" id="CustID" class="from-control select2" data-placeholder="Pilih CustID ...">
            <option value="">--Pilih--</option>
            @{
                foreach (var custid in ViewBag.custid)
                {
                    <option value="@custid ">@custid</option>
                }
            }
        </select>*@
                            <!--<select class="form-control select2-blue">
        <option value="value">text</option>
    </select>
    </div>-->
                            <div class="form-group">
                                <label for="CustName">Customer ID <span style="color:red">*</span></label>
                                @*<input type="text" class="form-control" id="CustName" name="Name" placeholder="Enter Customer Name" autocomplete="off" required>*@
                                <select class=" select2" style="padding-bottom:10px;" data-placeholder="Select CustID ..." name="CustID" id="CustID">
                                    <option value="">--Pilih--</option>
                                    @{
                                        foreach (var custid in ViewBag.custid)
                                        {
                                            <option value="@custid ">@custid</option>
                                        }
                                    }
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="CustName">Customer Name <span style="color:red">*</span></label>
                                <input type="text" class="form-control" id="CustName" name="Name" placeholder="Enter Customer Name" autocomplete="off" required>
                            </div>
                            <div class="form-group">
                                <label for="Email">Email address <span style="color:red">*</span></label>
                                <input type="email" class="form-control" id="Email" name="Email" placeholder="Enter Email" autocomplete="off" required>
                            </div>
                        </div>
                    </div>
                    <div class="text-right mt-2">
                        <button type="button" class="btn btn-danger waves-effect waves-light" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary btn-waves-effect waves-light">
                            Submit
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>
<div class="modal fade" id="modalEditUser" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <form class="form-parsley" id="form-edit">
                <div class="modal-header px-4 bg-light">
                    <h4 class="modal-title" id="addModalLabel">Edit User</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
                <div class="modal-body p-4">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="form-group">
                                <label for="EditCustID">Customer Id *</label>
                                <input type="text" class="form-control" id="EditCustID" name="CustID" placeholder="Customer Id" autocomplete="off" required disabled>
                            </div>
                            <div class="form-group">
                                <label for="EditCustName">Customer Name *</label>
                                <input type="text" class="form-control" id="EditCustName" name="Name" placeholder="Customer Name" autocomplete="off" required>
                            </div>
                            <div class="form-group">
                                <label for="EditEmail">Email address *</label>
                                <input type="email" class="form-control" id="EditEmail" name="Email" placeholder="Email" autocomplete="off" required>
                            </div>
                        </div>
                    </div>
                    <div class="text-right mt-2">
                        <button type="button" class="btn btn-danger waves-effect waves-light" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary btn-waves-effect waves-light">
                            Update
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

@section scripts
{
    <script>
        var table;
        var customerID;
        var RETURNURL = "https://localhost:44334/Account/Index";
        var ListCustID;
        $(".select2").select2({
            dropdownParent: $('#modalAddUser'),
            width: '62.5%',
            theme: "bootstrap4",
        });
        $(document).ready(function () {
            GetCustIDList();
            table = $("#user-table").DataTable({
                "ajax": {
                    "url": '@Url.Action("GetUser","Account")',
                    "type": "GET",
                    "datatype" : "JSON"
                },
                "columns": [
                    { "data": "CustID" },
                    { "data": "Name" },
                    { "data": "Email" },
                    {
                        "data": "IsActive",
                        "sClass": "text-center",
                        "render": function (data) {
                            if (data == false) return '<span class="btn btn-block btn-danger btn-sm" >INACTIVE</span> ';
                            if (data == true) return '<span class="btn btn-block btn-success btn-sm">ACTIVE</span>';
                        }
                    },
                    {
                        "data": "Verified",
                        "sClass": "text-center",
                        "render": function (data) {
                            if (data == false) return '<span class="btn btn-block btn-danger btn-sm" >NO </span> ';
                            if (data == true) return '<span class="btn btn-block btn-success btn-sm">YES</span>';
                        }
                    },
                    {
                        "searchable": false, "orderable": false, "sClass": "text-center", "width": "16%", "render": function (data, type, row) {
                            let btnActivated = "btn-info";
                            let btnText = "Activated";
                            if (row.IsActive === true) {
                                btnActivated = "btn-danger";
                                btnText = "Deactivated";
                            }
                            return '<button type="button" data="' + row.CustID + '" data-status="' + row.IsActive + '" class="btn btn-block btn-sm ' + btnActivated + '" onclick="activatedUser(this,event);" id="btn-isActive">' + btnText + '</button>';
                        }
                    },
                    {
                        "searchable": false, "orderable": false, "sClass": "text-center", "width": "16%", "render": function (data, type, row) {
                            return '<button type="button" data="' + row.CustID + '" class="btn btn-primary btn-sm" onclick="editUser(this,event); "><i class="far fa-edit"></i></button>   <button type="button" data="' + row.CustID + '" class="btn  btn-danger btn-sm" onclick="deleteUser(this,event);"><i class="fas fa-trash-alt"></i></button>';
                        }
                    }
                ]
            });
        });

        $("#form-create").submit(function (event) {
            event.preventDefault();
            $.ajax({
                url: "Account/Create",
                type: "post",
                dataType: "json",
                data: $(this).serialize(),
                beforeSend: function () {
                    Swal.fire({
                        title: 'Saving...',
                        html: "Save User details.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    if (data.metaData.code == 200) {
                        $('#modalAddUser').modal('hide');
                        table.ajax.reload();
                        messageSuccess(data.metaData.message, null);
                    } else {
                        $('#modalAddUser').modal('hide');
                        messageFailed(data.metaData.message);
                    }
                },
                error: function (result) {
                    console.log("error", result);
                }
            });
        });
        $("#form-edit").submit(function (event) {
            event.preventDefault();
            let custId = customerID;
            let formData = new FormData();
            formData.append("CustID", custId);
            formData.append("Name", $("#EditCustName").val());
            formData.append("Email", $("#EditEmail").val());
            $.ajax({
                url: "Account/Update/" + custId,
                type: "post",
                dataType: "json",
                data: formData,
                processData: false,
                processData: false,
                contentType: false,
                beforeSend: function () {
                    Swal.fire({
                        title: 'Updating',
                        html: "Update User details.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    if (data.metaData.code == 200) {
                        $('#modalEditUser').modal('hide');
                        table.ajax.reload();
                        messageSuccess(data.metaData.message, null);
                    } else {
                        $('#modalEditUser').modal('hide');
                        messageFailed(data.metaData.message, null);
                    }
                },
                error: function (result) {
                    console.log("error", result);
                }
            });
        });

        window.editUser = (input, evt) => {
            let custId = $(input).attr('data');
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Content("~/Account/AmbilUser")',
                dataType: 'JSON',
                type: 'POST',
                data: JSON.stringify({ "custId": custId }),
                success: function (data) {
                    let user = data.response;
                    customerID = user.CustID;
                    $("#EditCustID").val(user.CustID);
                    $("#EditCustName").val(user.Name);
                    $("#EditEmail").val(user.Email);
                    $('#modalEditUser').modal('show');
                },
                error: function (error) {
                    alert("error" + error);
                }
            })
        }
        window.deleteUser = (input, evt) => {
            let custId = $(input).attr('data');
            Swal.fire({
                title: 'Delete User',
                icon: "warning",
                text: 'This user will be deleted, are you sure?',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                cancelButtonText: 'Cancel',
                confirmButtonText: 'Yes (Delete)',
                showLoaderOnConfirm: true,
                preConfirm: (login) => {
                    return $.ajax({
                        url: '@Url.Content("~/Account/Delete")',
                        type: "post",
                        dataType: "json",
                        data: JSON.stringify({ "custId": custId }),
                        contentType: 'application/JSON; charset=utf-8'
                    }).then(response => {
                        if (!response.ok) {
                            messageFailed(response.statusText)
                        }
                        return response;
                    }).then(result => {
                        if (result.metaData.code === 200) {
                            messageSuccess(result.metaData.message, null)
                            table.ajax.reload();
                        } else {
                            messageFailed(result.metaData.message)
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: ${error}`
                        )
                    })
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }
        window.activatedUser = (input, evt) => {

            let status = $(input).attr('data-status');
            let data = $(input).attr('data');
            let title = "Deactivate User";
            let text = "This user will be deactivated, are you sure?"

            if (status == "false") {
                title = "Activate User"
                text = "This user will be activated, are you sure?"
            }

             Swal.fire({
                title: title,
                icon: "warning",
                text: text,
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                cancelButtonText: 'Cancel',
                confirmButtonText: 'Yes',
                showLoaderOnConfirm: true,
                preConfirm: (login) => {
                    return $.ajax({
                        url: '@Url.Content("~/Account/AktifkanUser")',
                        type: "post",
                        dataType: "json",
                        data: JSON.stringify({ "custId": data, "status" : status}),
                        contentType: 'application/JSON; charset=utf-8'
                    }).then(response => {
                        if (!response.ok) {
                            messageFailed(response.statusText)
                        }
                        return response;
                    }).then(result => {
                        if (result.metaData.code === 200) {
                            messageSuccess(result.metaData.message, null)
                            table.ajax.reload();
                        } else {
                            messageFailed(result.metaData.message)
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: Email can't be sent`
                        )
                    })
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }
        $("#btn-reload").click(function () {
            alert("Data successfully reloaded!");
            table.ajax.reload();
            console.log("selesai");
        });

        console.log(typeof ListCustID + " " + "data: " + ListCustID);
        let list = [];
        function GetCustIDList() {

            $.ajax({
                url: '@Url.Action("GetListCustIDs", "Account")',
                dataType: 'json',
                type: 'get',
                success: function (result) {
                    result.data.forEach(function (dt) {
                        list.push(dt);
                    });
                },
                error: function (result) {
                    console.log("error " + result)
                }
            });
        }
        console.log("list " + list)
    </script>
}